stages:
  - validate
  - test
  - deploy

checkstyle:
  tags:
    - docker
  image: python:3.8
  stage: validate
  before_script:
    - pip install -r requirements-dev.txt
  script:
    - pycodestyle --show-source --show-pep8 --exclude="venv,*/_version.py,versioneer.py"

check_dependencies:
  tags:
    - docker
  image: python:3.8
  stage: validate
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
  script:
    - liccheck -s liccheck.ini -r requirements.txt

unittests_3.8:
  tags:
    - docker
  image: python:3.8
  stage: test
  variables:
    JAVA_HOME: /usr/lib/jvm/default-java/
  before_script:
    - apt update
    - apt install -y default-jdk
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - python -m unittest -v

unittests_3.11:
  tags:
    - docker
  image: python:3.11
  stage: test
  variables:
    JAVA_HOME: /usr/lib/jvm/default-java/
  before_script:
    - apt update
    - apt install -y default-jdk
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - python -m unittest -v

unittests_windows:
    tags:
      - windows
    image: winamd64/python:3.11
    stage: test
    variables:
      JAVA_HOME: $CI_PROJECT_DIR\jvm\
    before_script:
      - curl "https://download.oracle.com/java/17/latest/jdk-17_windows-x64_bin.zip" -o java.zip
      - Expand-Archive -Force java.zip jvm
      - pip install -r requirements.txt -r requirements-dev.txt
      - python -m build
    script:
      - python -m unittest -v
    allow_failure: true

release:
  tags:
    - docker
  image: python:3.8
  stage: deploy
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
  script:
    - python -m build
    - pip install dist/drb-topic-landsat8-$CI_COMMIT_TAG.tar.gz
    - python -m twine upload dist/*
  only:
    - tags